
#---  The Main testing programs :

DEMO_MAIN = laplace.F

DEMO_OBJ = $(DEMO_MAIN:%.F=%.o)

PROG = $(DEMO_OBJ:%.o=%.exe)


#---  The Laplace aux routines

CC_SRC   = Init_Task_Grid_demo.c \
           Laplace_Iter_incre.c Laplace_Iter_decre.c
CC_OBJ   = $(CC_SRC:.c=.o)

#---  The Debugging routine :

debug_C_SRC = print_Task_Grid.c
debug_F_SRC = last_ctg_dim.f \
              print_Task_c4Grid.f print_Task_c8Grid.f \
              print_Task_r4Grid.f print_Task_r8Grid.f \
              print_Task_iGrid.f
debug_OBJ   = $(debug_C_SRC:.c=.o) $(debug_F_SRC:.f=.o)



#---  MPI include file location:
INC_MPI = $(MPI_HOME)/include

#---  Compilers Flag:
FC      = f77
CC      = cc
AR      = ar
RANLIB  = ranlib
LINKER  = mpif77


# SUN5/HP-UX FFLAGS 
# FFLAGS = +E6 +U77 -c -O

# default DIM2 for Ndim=2,     Specify -DDIM3 : DIM3 for Ndim=3

FFLAGS = -DDEBUG -DDEBUG_stdout -c -g
#FFLAGS = -DDEBUG_stdout -c -g 
#FFLAGS = -c -O2


# gcc flags for ansi
CFLAGS  = -ansi -pedantic -Wformat -DDEBUG -DDEBUG_stdout -c -g
#CFLAGS  = -ansi -pedantic -Wformat -DDEBUG_stdout -c -g
#CFLAGS  = -ansi -pedantic -Wformat -DDEBUG -c -O2

# IRIX6's native cc
#CFLAGS  =  -DFortranSingleUnderscore -DDEBUG -DDEBUG_stdout -c -g


# AR's FLAG
ARFLAGS = -crl


#---  Code Conversion Rules:
#.f.o:
%.o:	%.f
	$(FC) $(FFLAGS) $< -I$(INC_MPI)

#.F.o:
%.o:	%.F
	$(FC) $(FFLAGS) $< -I$(INC_MPI)

#.c.o:
%.o:	%.c
	$(CC) $(CFLAGS) $< -I$(INC_MPI)

%.exe:	%.o $(CC_OBJ) $(debug_OBJ) ../lib/librgx.a
	$(LINKER) -o $@ $< $(CC_OBJ) $(debug_OBJ) ../lib/librgx.a

#-------------------------------------------------------------------
all:	obj exe

obj:		../lib/librgx.a $(CC_OBJ) $(debug_OBJ) $(DEMO_OBJ)

exe:		obj ../lib/librgx.a $(PROG)
		mv $(PROG) ../bin


#--------------------------------------------------
Init_Task_Grid_demo.o:           debug.c.h
Laplace_Iter.o:                  debug.c.h
#--------------------------------------------------

clean:
	rm -f *.o $(PROG) ../bin/$(PROG)  
	rm -f node_*.txt ../node_*.txt core  *\~
