#include <stdio.h>
#include <string.h>


void exe_gplot_Task_Grid(
                          int          my_tid_demo,
                          int          iter_idx_demo,
                          char        *dirname,
                          char        *sub_dirname,
                          char        *filename,
                          int          Ndim,
                          int          geom_frame_offset[2],
                          int          geom_size[2]
                        )
{
#  include      "gplot.c.h"
#  define       demo_line_Max 80

   char         demo_cmd_str[ 2 * demo_line_Max ];
   char         pathname_demo[ demo_line_Max ];
   char         dirname_demo[ demo_line_Max ];
   char         sub_dirname_demo[ demo_line_Max ];
   char         filename_demo[ demo_line_Max ];

   const char   SED_com[]                     = "sed -e ";
   char         SED_arg[ demo_line_Max ];
   const char   DATAFILE[]                    = "DATAFILE-PATHNAME";
   const char  *gplot_template[2][2]          = {
                                                 {
                                                  "GNUPLOT_template_1D.cmd",
                                                  "GNUPLOT_template_1D.cmd"
                                                 },
                                                 {
                                                  "GNUPLOT_template_2D_pic.cmd",
                                                  "GNUPLOT_template_2D_mov.cmd"
                                                 }
                                                };
   char         gplot_cmd_file[ demo_line_Max ];

   const char   XTERM_com[]                   = "xterm -fn 5x7 -geom 80x5";

/*
   //  For  800x600 display  
   const char   GNUPLOT_com[]                 = "-e gnuplot -geometry 400x300";
   //  For 1024x768 display  
   const char   GNUPLOT_com[]                 = "-e gnuplot -geometry 500x375";
   const int    geom_offset[4][2]             = { {   0,   0 }, { 500,   0 },
                                                  {   0, 350 }, { 500, 350 } };
*/

   const char   GNUPLOT_com[]                 = "-e gnuplot -geometry ";

   const char   PLOTconsole[]                 = "-title PLOTconsole@";
   const char   GNUplot_hdr[]                 = "-title GNUplot@";

   const int    N_geom                        = 4;
   const int    geom_init[2]                  = {  0, 30 };
   const int    geom_incre[2]                 = { 20, 20 };
   const int    geom_frame_incre[2]           = { 30, 30 };
   const char   geom_coord_fmt[]              = "+%04d+%04d ";
   const char   geom_size_fmt[]               = "%04dx%04d";
   int          geom_offset[4][2];
   char         geom_coord_str[ demo_line_Max ];
   char         geom_size_str[ demo_line_Max ];
   int          geom_coord[2];
   int          geom_frame;
   int          geom_idx;

   char         demo_tmp_str[ demo_line_Max ];
   char         task_iter_status[ demo_line_Max ];
   char         tmp_fmt[ demo_line_Max ];
   int          ierr_demo;
   int          idir, ii;

 
      /* copy gplot-related variables to the cooresponding demo-related ones */
      strcpy( dirname_demo, dirname );
      strcpy( sub_dirname_demo, sub_dirname );
      strcpy( filename_demo, filename );

      /* prepare for the SED's argument, SED_arg  */
      strcpy( SED_arg, "\'s/" );
      strcat( SED_arg, DATAFILE );
      strcat( SED_arg, "/" );
      strcat( SED_arg, dirname_demo );
      strcat( SED_arg, "\\/" );
      strcat( SED_arg, sub_dirname_demo );
      strcat( SED_arg, "\\/" );
      strcat( SED_arg, filename_demo );
      strcat( SED_arg, "/g\'" );

      /* prepare for the task_iter_status  */
      sprintf( tmp_fmt, "%s_%s", task_fmt, iter_fmt );
      sprintf( task_iter_status, tmp_fmt, my_tid_demo, iter_idx_demo );

      /* prepare for the gplot command file's name, gplot_cmd_file  */
      sprintf( gplot_cmd_file, "gplot_%s.cmd", task_iter_status );

      /* Remove the gplot_cmd_file, if it exists, in the current working dir */
      sprintf( demo_cmd_str, "rm -rf " );
      strcat( demo_cmd_str, gplot_cmd_file );
      ierr_demo = system(  demo_cmd_str );

      /* prepare the string to create the gplot_cmd_file  */
      strcpy( demo_cmd_str, SED_com );
      strcat( demo_cmd_str, SED_arg );
      strcat( demo_cmd_str, " " );
      if ( iter_idx_demo == 0 )
         strcat( demo_cmd_str, gplot_template[ Ndim-1 ][ 0 ] );
      else
         strcat( demo_cmd_str, gplot_template[ Ndim-1 ][ 1 ] );
      strcat( demo_cmd_str, " > " );
      strcat( demo_cmd_str, gplot_cmd_file );

      /* Create the gplot_cmd_file from the gplot_template  */
      ierr_demo = system(  demo_cmd_str );
      /*   printf( "%s \n\n", demo_cmd_str );       */

      /* Create XTERM and its argument to execute GNUplot of gplot_cmd_file */

      /* variable to determine which geom_idx in which geom_frame  */
      geom_idx   = my_tid_demo % N_geom;
      geom_frame = my_tid_demo / N_geom;

      /* determine the plot's relative position (in a frame) w.r.t. geom_size */
      geom_offset[0][0] = 0;            geom_offset[0][1] = 0;
      geom_offset[1][0] = geom_size[0]; geom_offset[1][1] = 0;
      geom_offset[2][0] = 0;            geom_offset[2][1] = geom_size[1];
      geom_offset[3][0] = geom_size[0]; geom_offset[3][1] = geom_size[1];
      
      for ( idir = 0; idir < 2; idir++ )
         geom_coord[ idir ] = geom_init[ idir ]
                            + geom_frame * geom_frame_incre[ idir ]
                            + geom_offset[ geom_idx ][ idir ]
                            + geom_frame_offset[ idir ];

      sprintf( geom_coord_str, geom_coord_fmt, geom_coord[0], geom_coord[1] );
      sprintf( geom_size_str, geom_size_fmt, geom_size[0], geom_size[1] );

      strcpy( demo_cmd_str, XTERM_com );
      strcat( demo_cmd_str, geom_coord_str );
      strcat( demo_cmd_str, PLOTconsole );
      strcat( demo_cmd_str, task_iter_status );
      strcat( demo_cmd_str, "  " );
      strcat( demo_cmd_str, GNUPLOT_com );
      strcat( demo_cmd_str, geom_size_str );  
      for ( idir = 0; idir < 2; idir++ )
         geom_coord[ idir ] += geom_incre[ idir ];
      sprintf( geom_coord_str, geom_coord_fmt, geom_coord[0], geom_coord[1] );
      strcat( demo_cmd_str, geom_coord_str );
      strcat( demo_cmd_str, GNUplot_hdr );
      strcat( demo_cmd_str, task_iter_status );
      strcat( demo_cmd_str, " " );
      strcat( demo_cmd_str, gplot_cmd_file );
      strcat( demo_cmd_str, " &" );

      /* EXcute GNUPLOT  */
      /* for ( ii = 0; ii < N_beep; ii++ ) printf( "\a" ); */
      ierr_demo = system( demo_cmd_str );
      /* printf( "%s \n\n", demo_cmd_str );  */

      /*
      printf( "Task %d : ierr_demo for xterm -e gplot = %d\n",
              my_tid_demo, ierr_demo );
      sprintf( demo_tmp_str, getenv( "DISPLAY" ) );
      printf( "Task %d : DISPLAY = %s\n", my_tid_demo, demo_tmp_str );
      */
}
