      Program test

      implicit none

      integer N_iter
      parameter ( N_iter = 200 )
      integer Nmax
      parameter ( Nmax = 17*2 )
      real*8 phi(0:Nmax+1), phi_old(0:Nmax+1), phi_sol(0:Nmax+1)

      integer mode
      real*8 pi
      real*8 delta, parm, parm_sq
      integer count, ii, jj

      integer istep, prev_istep, Nprint, icenter
      real*8 rtmp, sum

      pi = 4.0d0 * datan( 1.0d0 )
      write(6,*) 'pi = ', pi

      delta = 1.0d0 / ( Nmax + 1 )
      mode = 2
      parm  = delta * mode * pi
      parm_sq = parm * parm

c  Set Up Boundary Condition
      phi( 0 ) = 0
      phi( Nmax+1 ) = 0

      do ii = 1, Nmax/2
         phi( ii ) = 1.0d0
      enddo

      do ii = Nmax/2+1, Nmax
         phi( ii ) = -1.0d0
      enddo

c  Set the guessed solultion

      phi_sol( 0 ) = 0
      phi_sol( Nmax+1 ) = 0
      do ii = 1, Nmax
         phi_sol( ii ) = dsin( parm * ii )
      enddo
      icenter = ( Nmax + 1 ) / 2

c  Start the calculation
      Nprint = 10
      prev_istep = 0
      do count = 1, N_iter

         istep = count / Nprint
         if ( istep .gt. prev_istep ) then
            write(6,*)
            prev_istep = istep
            write(6,*) 'count = ', count
            sum = 0.0d0
            do ii = 0, Nmax+1
               write(6,*) ii, ',  ', phi( ii ), 
     &                    ' :  ', phi( icenter ) * phi_sol( ii )
               rtmp = phi( ii ) - phi_old( ii )
               sum = sum + rtmp * rtmp
            enddo
            write(6,*) 'sum of error = ', sum
c           pause
         endif

         do ii = 0, Nmax+1
            phi_old( ii ) = phi( ii )
         enddo

         do ii = 1, Nmax
            phi( ii ) = ( phi_old( ii-1 ) + phi_old( ii+1 ) )
     &                / ( 2 - parm_sq )
         enddo

      enddo

      end         
